-- 32 bit szamlalo
-- VaJo
-- quartus II sp13.0.1
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity c32ce is
    port(clk : in std_logic; -- clk
			ce : in std_logic; -- engedelyezo
			dir: in std_logic;
			rst: in std_logic;
			q : out std_logic_vector(31 downto 0));
			
end entity c32ce;

architecture Behavioral of c32ce is
	 -- ha dir=1 akkkor elore ha dir=0 akkor vissza
    signal tmp: std_logic_vector(31 downto 0);
begin
	 process (clk, ce, rst)
    begin
        if (clk'event and clk='1') then
          if (rst='0') then
            tmp <= "00000000000000000000000000000000";
          else
				if (ce = '1') then
					if dir = '1' then	-- elore
						tmp <= tmp +1;
					else
						tmp <= tmp-1;
					end if;	
				end if;
			 end if;
        end if;
    end process;
	 q <= tmp;
end Behavioral;